//
// クロック・マネージャと，VGA出力機能を追加したbmpparserモジュール(bmpparser2)の
// インスタンスを生成するトップモジュール
//
`default_nettype none

module xilinx(clk, reset, tx, rx, led, r, g, b, hsync, vsync);

    input  wire clk;   // 入力クロック
    input  wire reset; // リセット信号．'1'のときに回路をリセット
    output wire tx;    // シリアル信号の出力
    input  wire rx;    // シリアル信号の入力
    output wire [3:0] led;
    output wire r, g, b, hsync, vsync;

    // PLLのインスタンスを生成
    wire CLK25M;
    pll u_pll(.CLK_IN1(clk), .CLK_OUT1(CLK25M), .LOCKED());

    bmpparser2#(.sys_clk(25000000), .rate(115200))
    u(.clk(CLK25M), .reset(reset), .tx(tx), .rx(rx), .led(led), .r(r), .g(g), .b(b), .hsync(hsync), .vsync(vsync));

endmodule // xilinx

`default_nettype wire

