`default_nettype none

module grayscale(
     input  wire clk,
     input  wire reset,
     input  wire req,
     input  wire[31:0] size,
     input  wire[31:0] offset,
     output reg we,
     output reg [20:0] waddr,
     output reg [7:0] wdata,
     output reg [20:0] raddr,
     input  wire [7:0] rdata,
     output reg done
);

    reg [31:0] i;
    reg [16:0] r, g, b;
    reg [16:0] val;

    reg [2:0] state; // ԂCʂ邽߂̕ϐ
    reg [3:0] substate;

    always @(posedge clk) begin
        if(reset == 1'b1) begin
            state <= 2'b00;
            substate <= 0;
            i <= 31'h00000000;
            done <= 1'b1;
            raddr <= 0;
            we <= 1'b0;
        end else begin
            case(state)
                0: begin
                    if(req == 1'b1) begin
                        state <= state + 1;
                        done <= 1'b0;
                        i <= 32'h00000000;
                        substate <= 0;
                    end else begin
                        done <= 1'b1;
                    end
                    we <= 1'b0;
                end
                1: begin // 1
                    case(substate)
                        0: begin
                            if(i >= size) begin
                                done <= 1'b1;
                                state <= 0; // ܂
                            end else begin
                                raddr <= offset + 3 * i; // 荞ރAhXw
                                substate <= substate + 1;
                            end
                        end
                        1: substate <= substate + 1; // 1NbN҂
                        2: begin
                            b <= {8'h00, rdata};
                            substate <= substate + 1;
                        end
                        3: begin
                            raddr <= offset + 3 * i + 1;
                            substate <= substate + 1;
                        end
                        4: substate <= substate + 1;
                        5: begin
                            g <= {8'h00, rdata};
                            substate <= substate + 1;
                        end
                        6: begin
                            raddr <= offset + 3 * i + 2;
                            substate <= substate + 1;
                        end
                        7: substate <= substate + 1;
                        8: begin
                            r <= {8'h00, rdata};
                            substate <= 0;
                            state <= state + 1;
                        end
                    endcase // case (substate)
                end
                2: begin // 2
                    val <= (77 * r + 150 * g + 29 * b) >> 8;
                    state <= state + 1;
                    substate <= 0;
                end
                3: begin // 3
                    case(substate)
                        0: begin
                            waddr <= offset + 3 * i;
                            wdata <= val;
                            we <= 1'b1;
                            substate <= substate + 1;
                        end
                        1: begin
                            waddr <= offset + 3 * i + 1;
                            wdata <= val;
                            we <= 1'b1;
                            substate <= substate + 1;
                        end
                        2: begin
                            waddr <= offset + 3 * i + 2;
                            wdata <= val;
                            we <= 1'b1;
                            state <= 1;
                            substate <= 0;
                            i <= i + 1;
                        end
                    endcase // case (substate)
                end
            endcase
        end
    end

endmodule

`default_nettype wire
