#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <termios.h>
#include <time.h>

#define BAUD_RATE    B115200      // RS232C f[^][g
#define BUFF_SIZE    4096

void serial_init(int fd)
{
  struct termios tio = {0};
  tio.c_cflag = CS8 | CLOCAL | CREAD;
  tio.c_cc[VTIME] = 100;
  // ][g̐ݒ
  cfsetispeed(&tio,BAUD_RATE);
  cfsetospeed(&tio,BAUD_RATE);
  // foCXɐݒs
  tcsetattr(fd,TCSANOW,&tio);
}


int main(int argc, char **argv){
  int fd, src, dest;
  int size = 0;
  int len;
  unsigned char buffer[BUFF_SIZE];

  if(argc < 4){
	fprintf(stderr, "usage: %s COM SRC DEST\n", argv[0]);
	exit(1);
  }
  
  if((fd = open(argv[1], O_RDWR | O_BINARY)) < 0){
	fprintf(stderr, "cannot open serial port: %s", argv[1]);
	exit(1);
  }
  serial_init(fd);
  
  
  if((src = open(argv[2], O_RDONLY | O_BINARY)) < 0){
	fprintf(stderr, "cannot open src image: %s", argv[2]);
	exit(1);
  }
  
  if((dest = open(argv[3], O_WRONLY | O_CREAT | O_BINARY, S_IREAD | S_IWRITE)) < 0){
	fprintf(stderr, "cannot open dest image: %s", argv[3]);
	exit(1);
  }

  while(1){
	len = read(src, buffer, BUFF_SIZE);
	if(len == 0) break;
	write(fd, buffer, len);
	size += len;
  }

  printf("send: %d\n", size);

  while(1){
	len = read(fd, buffer, BUFF_SIZE);
	if(len < 0){ // read̖߂lG[ȂI/OG[
	  fprintf(stderr, "I/O error: %s\n", argv[1]);
	  exit(1);
	}
	write(dest, buffer, len);
	size -= len;
	if(size <= 0) break;
  }

  close(fd);
  close(src);
  close(dest);

  return 0;
}
